<?php

App::uses('EvRobotsAppController', 'EvRobots.Controller');

class RobotsController extends EvRobotsAppController {

	/**
	 * Override the default functionality and have a simple form to update the robots.txt
	 * If the file isn't writable, display a template saying so.
	 *
	 * @return void
	 */
	public function admin_index() {
		$this->viewPath = 'Robots';
		$robotsFilepath = APP . WEBROOT_DIR . '/robots.txt';

		if (is_writable($robotsFilepath)) {
			if ($this->request->is(['post']) && isset($this->request->data['Robots']['content'])) {
				$robotsFile = fopen($robotsFilepath, 'wb+');

				if (fwrite($robotsFile, $this->request->data['Robots']['content'])) {
					$this->Flash->success(['title' => 'Update Successful', 'description' => 'Your robots.txt file has been updated']);
					$Email = new CustomEmail();
					$Email->deliver('tim+lean@evoluted.net', $_SERVER['HTTP_HOST'] . ' \'s robots.txt file updated.', nl2br($this->request->data['Robots']['content']), 'sendgrid', true);
				} else {
					$this->Flash->fail(['title' => 'Update Failed', 'description' => 'Your robots.txt file has not been updated']);
				}

				fclose($robotsFile);

				$this->redirect($this->here);
			}

			$this->set('robotsContent', file_get_contents($robotsFilepath));
			$this->view = 'writable';
		} else {
			$this->view = 'not_writable';
		}
	}
}
